// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <atomic>
#include <string>
#include <thread>

#include <boost/filesystem.hpp>

namespace Azure { namespace Device { namespace ErrorReporting {
namespace Uploader {

class KernelMessageMonitor
{
  public:
    KernelMessageMonitor();
    ~KernelMessageMonitor();

    void Run();
    void Stop();

  private:
    void MessageThreadRun();
    void ProcessMessage(std::string_view message);
    void CreateOrReplaceSentinel();
    void CheckForSentinel();

    boost::filesystem::path GetSentinelPath();

  private:
    std::atomic_bool m_isStopping;
    std::thread m_thread;
    int m_stopDescriptor;
};

}}}}
