// Copyright (c) Microsoft Corporation. All rights reserved.

#pragma once

#include <string>
#include <vector>

#include <boost/filesystem.hpp>

#include "ErrorReportUploadServiceBase.h"
#include "HttpReportUploader.h"
#include "LocalPolicyManager.h"

namespace Azure { namespace Device { namespace ErrorReporting {
namespace Uploader {

class HttpErrorReportUploadService : public ErrorReportUploadServiceBase
{
  public:
    HttpErrorReportUploadService(Policy::LocalPolicyManager& localPolicyManager);
    ~HttpErrorReportUploadService();

  private:
    void AddOsVersion(HttpReportUploader& report);
    void UploadReport(const boost::filesystem::path& reportPath) override;
};

}}}}
